#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <linux/joystick.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <string.h>

void send_state(int val, char button);


static char server[256]="131.151.188.33";
static unsigned short server_port=8000;
struct sockaddr_in host;
static int sock;

int main(int argc, char **argv)
{
	int fd;
	int val;
	char button;
	struct js_event js;

	if (argc>1) {
		strcpy(server,argv[1]);
	}
	if (argc>2) {
		server_port=atoi(argv[2]);
	}
	
	host.sin_family=AF_INET;
	host.sin_addr.s_addr=inet_addr(server);
	host.sin_port=htons(server_port);
	bzero(&host.sin_zero,8);

	sock=socket(AF_INET,SOCK_DGRAM,0);

	fd=open("/dev/js0",O_RDONLY);
	if (fd<0) {
		perror("main: open");
		exit(1);
	}

	while (1) {
		
		if (read(fd,&js,sizeof(struct js_event)) != sizeof(struct js_event)) {
			perror("joystick_reader: error reading");
			exit(1);
		}
		
		if (js.number==0) {
    		switch(js.type & ~JS_EVENT_INIT) {
    		case JS_EVENT_BUTTON:
    			button=js.value;
    			break;
    		case JS_EVENT_AXIS:
    			val=js.value;
    			break;
    		}
    		
    		send_state(val,button);
		}
	}	
	
	return 0;
}

void send_state(int val, char button)
{
	char buf[10];
	memcpy(buf,&val,sizeof(int));
	memcpy(&buf[sizeof(int)],&button, sizeof(char));
	
	sendto(sock,&buf,sizeof(int)+sizeof(char),0,(struct sockaddr *) &host,sizeof(struct sockaddr));
	
	printf("val: %d   button: %d            \r",val,(int) button);
	fflush(stdout);
	
}
