#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <linux/joystick.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <string.h>
#include <unistd.h>
#include <termios.h>

void send_state(int val, char button);


static char server[256]="131.151.188.33";
static unsigned short server_port=8000;
struct sockaddr_in host;
static int sock;

int main(int argc, char **argv)
{
	int fd;
	int val=0;
	int c;
	char button;
	struct js_event js;

	if (argc>1) {
		strcpy(server,argv[1]);
	}
	if (argc>2) {
		server_port=atoi(argv[2]);
	}
	
	set_raw_mode();

	host.sin_family=AF_INET;
	host.sin_addr.s_addr=inet_addr(server);
	host.sin_port=htons(server_port);
	bzero(&host.sin_zero,8);

	sock=socket(AF_INET,SOCK_DGRAM,0);

/*	fd=open("/dev/js0",O_RDONLY);
	if (fd<0) {
		perror("main: open");
		exit(1);
	}
*/
	while (1) {
		
		c=getchar();
		
		switch(c) {
		case 'a':
			val-=4000;
			break;
		case 's':
			val+=4000;
			break;
		}
    		
    		send_state(val,button);
	}	
	
	return 0;
}

int set_raw_mode()
{
     int fd = STDIN_FILENO;
    struct termios t;

    if (tcgetattr(fd, &t) < 0)
    {
        perror("tcgetattr");
        return -1;
    }

    t.c_lflag &= ~ICANON;

    if (tcsetattr(fd, TCSANOW, &t) < 0)
    {
        perror("tcsetattr");
        return -1;
    }

    setbuf(stdin, NULL);

    return 0;
}



void send_state(int val, char button)
{
	char buf[10];
	memcpy(buf,&val,sizeof(int));
	memcpy(&buf[sizeof(int)],&button, sizeof(char));
	
	sendto(sock,&buf,sizeof(int)+sizeof(char),0,(struct sockaddr *) &host,sizeof(struct sockaddr));
	
	printf("val: %d   button: %d            \r",val,(int) button);
	fflush(stdout);
	
}
