#ifndef PATTERN_H
#define PATTERN_H 1

#include <gtk/gtk.h>
#include "../../interface_2001.h"

#define max(x,y) ( ((x) < (y)) ? (y) : (x))
#define min(x,y) ( ((x) > (y)) ? (y) : (x))



struct pattern_info {
	gint (* init)(gchar *param);
	gint (* frame)(gdouble bar_averages[NUM_SEGMENTS], gint16 bar_heights[NUM_SEGMENTS], 
					gint light_data[NUM_SEGMENTS*6], gint16 raw_data[2][256], gint time_left);
	gint (* deinit)(void);
};

gint simple_equalizer_init(gchar *param);
gint simple_equalizer_deinit(void);
gint simple_equalizer_frame(gdouble bar_averages[NUM_SEGMENTS], gint16 bar_heights[NUM_SEGMENTS], 
		gint light_data[NUM_SEGMENTS*6], gint16 raw_data[2][256], gint time_left);

gint sine_wave_init(gchar *param);
gint sine_wave_deinit(void);
gint sine_wave_frame(gdouble bar_averages[NUM_SEGMENTS], gint16 bar_heights[NUM_SEGMENTS], 
		gint light_data[NUM_SEGMENTS*6], gint16 raw_data[2][256], gint time_left);


gint ring_equalizer_init(gchar *param);
gint ring_equalizer_deinit(void);
gint ring_equalizer_frame(gdouble bar_averages[NUM_SEGMENTS], gint16 bar_heights[NUM_SEGMENTS], 
		gint light_data[NUM_SEGMENTS*6], gint16 raw_data[2][256], gint time_left);

gint trailing_lines_init(gchar *param);
gint trailing_lines_deinit(void);
gint trailing_lines_frame(gdouble bar_averages[NUM_SEGMENTS], gint16 bar_heights[NUM_SEGMENTS],
		gint light_data[NUM_SEGMENTS*6], gint16 raw_data[2][256], gint time_left);

gint rise_init(gchar *param);
gint rise_deinit(void);
gint rise_frame(gdouble bar_averages[NUM_SEGMENTS], gint16 bar_heights[NUM_SEGMENTS],
		gint light_data[NUM_SEGMENTS*6], gint16 raw_data[2][256], gint time_left);

gint bar_equalizer_init(gchar *param);
gint bar_equalizer_deinit(void);
gint bar_equalizer_frame(gdouble bar_averages[NUM_SEGMENTS], gint16 bar_heights[NUM_SEGMENTS],
		gint light_data[NUM_SEGMENTS*6], gint16 raw_data[2][256], gint time_left);

gint random_spots_init(gchar *param);
gint random_spots_deinit(void);
gint random_spots_frame(gdouble bar_averages[NUM_SEGMENTS], gint16 bar_heights[NUM_SEGMENTS],
		gint light_data[NUM_SEGMENTS*6], gint16 raw_data[2][256], gint time_left);

gint auto_pong_init(gchar *param);
gint auto_pong_deinit(void);
gint auto_pong_frame(gdouble bar_averages[NUM_SEGMENTS], gint16 bar_heights[NUM_SEGMENTS],
		gint light_data[NUM_SEGMENTS*6], gint16 raw_data[2][256], gint time_left);

gint center_meter_init(gchar *param);
gint center_meter_deinit(void);
gint center_meter_frame(gdouble bar_averages[NUM_SEGMENTS], gint16 bar_heights[NUM_SEGMENTS],
		gint light_data[NUM_SEGMENTS*6], gint16 raw_data[2][256], gint time_left);

gint brightness_level_init(gchar *param);
gint brightness_level_deinit(void);
gint brightness_level_frame(gdouble bar_averages[NUM_SEGMENTS], gint16 bar_heights[NUM_SEGMENTS],
		gint light_data[NUM_SEGMENTS*6], gint16 raw_data[2][256], gint time_left);
		
gint vertical_meter_init(gchar *param);
gint vertical_meter_deinit(void);
gint vertical_meter_frame(gdouble bar_averages[NUM_SEGMENTS], gint16 bar_heights[NUM_SEGMENTS],
		gint light_data[NUM_SEGMENTS*6], gint16 raw_data[2][256], gint time_left);

gint swirl_meter_init(gchar *param);
gint swirl_meter_deinit(void);
gint swirl_meter_frame(gdouble bar_averages[NUM_SEGMENTS], gint16 bar_heights[NUM_SEGMENTS],
		gint light_data[NUM_SEGMENTS*6], gint16 raw_data[2][256], gint time_left);

gint vertical_spectrum_init(gchar *param);
gint vertical_spectrum_deinit(void);
gint vertical_spectrum_frame(gdouble bar_averages[NUM_SEGMENTS], gint16 bar_heights[NUM_SEGMENTS],
		gint light_data[NUM_SEGMENTS*6], gint16 raw_data[2][256], gint time_left);

gint spinning_stripe_init(gchar *param);
gint spinning_stripe_deinit(void);
gint spinning_stripe_frame(gdouble bar_averages[NUM_SEGMENTS], gint16 bar_heights[NUM_SEGMENTS],
		gint light_data[NUM_SEGMENTS*6], gint16 raw_data[2][256], gint time_left);

gint warp_core_init(gchar *param);
gint warp_core_deinit(void);
gint warp_core_frame(gdouble bar_averages[NUM_SEGMENTS], gint16 bar_heights[NUM_SEGMENTS],
		gint light_data[NUM_SEGMENTS*6], gint16 raw_data[2][256], gint time_left);

gint explosion_init(gchar *param);
gint explosion_deinit(void);
gint explosion_frame(gdouble bar_averages[NUM_SEGMENTS], gint16 bar_heights[NUM_SEGMENTS],
		gint light_data[NUM_SEGMENTS*6], gint16 raw_data[2][256], gint time_left);


#endif
