#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

struct param_field {
	char *name;
	char type;
	void *val;
	struct param_field *next;
};

struct param_field *root;

/* functions to parse a parameter string and put the results into
   variables. */
   
int parse_string(char *string, char *format, ...)
{
	va_list argp;
	struct param_field *p,*p2;
	int i,index;
	char *nextpos,*prevpos;

	if (string==NULL) return 0;
	
	root=NULL;
	va_start(argp,format);
	
	for (i=0;i<strlen(format);i++) {
		p=(struct param_field *) malloc(sizeof(struct param_field));
		p->type=format[i];
		p->name=strdup(va_arg(argp, char *));
		p->val=strdup(va_arg(argp, void *));
		p->next=root;
		root=p;
	}
	
	va_end(argp);
	
	// now we need to go through string and see what pairs are there
	// we are looking for items of "<item>=<val>" separated by spaces
	
	index=0;
	nextpos=prevpos=string;
	
	while (nextpos) {
		nextpos=strchr(prevpos,'=');
		if (nextpos==NULL) break;	// there is no = sign
		
		// now that we have a key string from string[i] to nextpos, compare
		// it to all the values in our list
		
		for (p=root;p!=NULL;p=p->next) {
			if (strlen(p->name)==(nextpos-prevpos)) {
				if (strncmp(p->name,prevpos,strlen(p->name))==0) break;
			}
		}
		
		// if p==NULL then no match was found
		if (p) {
			// we have found a match... copy the value into
			// the mem location we remembered from before
			switch (p->type) {
			case 'i':
				*((int *)p->val)=atoi(nextpos+1);
				break;
			}
		}				
		nextpos=strchr(nextpos,' ');
		if (nextpos) nextpos++;
	}
	
	// delete our list
	p2=root;
	for (p=root->next;p!=NULL;p2=p, p=p->next) {
		if (p2) {
			free(p2->name);
			free(p2);
			p2=NULL;
		}
	}
	
	if (p2) {
		free(p2->name);
		free(p2);
		p2=NULL;
	}
	
	return 0;
}

	